Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:33:47 2011
FILE NAME: cflcheck.f90
PROGRAM NAME: cflcheck
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

    88  vec  (   4): Vectorized array expression.
    88  vec  (   4): Vectorized array expression.
    92  vec  (   4): Vectorized array expression.
    92  vec  (   4): Vectorized array expression.
   103  vec  (   4): Vectorized array expression.
   108  vec  (   4): Vectorized array expression.
   130  vec  (   4): Vectorized array expression.
   156  vec  (   4): Vectorized array expression.
   182  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:33:47 2011
FILE NAME: cflcheck.f90
PROGRAM NAME: cflcheck
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != Module CFLCheck
     2  !
     3  ! Authors::   SUGIYAMA Ko-ichiro
     4  ! Version::   $Id: cflcheck.f90,v 1.2 2011-10-04 05:19:02 sugiyama Exp $
     5  ! Tag Name::  $Name: arare5-20111010 $
     6  ! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
     7  ! License::   See COPYRIGHT[link:../../COPYRIGHT]
     8  !
     9  !== Overview
    10  !
    11  ! CFL Υå򤹤뤿Υѥå⥸塼
    12  !   * ȤФ CFL å
    13  !   * Ϥ줿®٤Ф CFL å
    14  !
    15  !== Error Handling
    16  !
    17  !== Known Bugs
    18  !
    19  !== Note
    20  !
    21  !== Future Plans
    22  !
    23  !Error Handling  gtool5 Ѥ褦ѹ
    24  !
    25  
    26  module CFLCheck
    27    !
    28    !CFL Υå򤹤뤿Υѥå⥸塼
    29    !  * ȤФ CFL å
    30    !  * Ϥ줿®٤Ф CFL å
    31    !
    32  
    33    !⥸塼ɤ߹
    34    use dc_types,   only: DP
    35    use dc_message, only: MessageNotify
    36  
    37    use gridset, only: imin,    &! x β
    38      &                imax,    &! x ξ
    39      &                jmin,    &! z β
    40      &                jmax,    &! z ξ
    41      &                kmin,    &! z β
    42      &                kmax      ! z ξ
    43    use axesset, only: xyz_dX,  &! x γʻֳ
    44      &                xyz_dY,  &! y γʻֳ
    45      &                xyz_dZ    ! z γʻֳ
    46    use timeset, only: DelTimeShort,  &!û֥ƥå
    47      &                DelTimeLong     !Ĺ֥ƥå
    48  
    49    !ۤηػ
    50    implicit none
    51  
    52    !private °λ
    53    private
    54  
    55    !
    56    character(*), parameter:: module_name = 'cflcheck'
    57                                ! ⥸塼̾.
    58                                ! Module name
    59  
    60    !ؿ public °
    61    public CFLCheckTimeShort
    62    public CFLCheckTimeLongVelX
    63    public CFLCheckTimeLongVelY
    64    public CFLCheckTimeLongVelZ
    65  
    66  contains
    67  
    68  !!!-----------------------------------------------------------------!!!
    69    subroutine CFLCheckTimeShort( xyz_VelSound )
    70      !
    71      !ȤФ CFL å
    72      !
    73  
    74      !ۤηػ
    75      implicit none
    76  
    77      !ѿ
    78      real(DP), intent(in) :: xyz_VelSound(imin:imax,jmin:jmax, kmin:kmax)
    79                                          !®
    80      real(DP)             :: xyz_CFL(imin:imax,jmin:jmax, kmin:kmax)
    81                                          !
    82  !    real(DP)             :: DxyzMin      !ǾʻҴֳ
    83  
    84      !® CFL 
    85  !    DxyzMin = min(min(minval(xyz_dx), minval(xyz_dy)), minval(xyz_dz))
    86  !    CFL = DelTimeShort * maxval(xyz_VelSound) / DxyzMin
    87  
    88      xyz_CFL = DelTimeShort * xyz_VelSound       &
     .        if (xyz_velsound.DSC.U2 + 1 - xyz_velsound.DSC.L2 .gt. 0) then    
     .           J1 = and(xyz_velsound.DSC.U2 + 1 - xyz_velsound.DSC.L2,3)      
     .  !CDIR    NODEP                                                          
     .           do t150 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t152 = 1, xyz_velsound.DSC.U1 + 1 - xyz_velsound.DSC.L1  
     .                 xyz_cfl(xyz_cfl.DSC.L1+t152-1,t150-1+xyz_cfl.DSC.L2,t148+
     .       1            xyz_cfl.DSC.L3) = deltimeshort*xyz_velsound(          
     .       2            xyz_velsound.DSC.L1+t152-1,t150-1+xyz_velsound.DSC.L2,
     .       3            t148+xyz_velsound.DSC.L3)*(1.00000000000000e+000/     
     .       4            xyz_dx(xyz_dx.DSC.L1+t152-1,t150-1+xyz_dx.DSC.L2,t148+
     .       5            xyz_dx.DSC.L3)**2.00000000000000e+000+                
     .       6            1.00000000000000e+000/xyz_dy(xyz_dy.DSC.L1+t152-1,t150
     .       7            -1+xyz_dy.DSC.L2,t148+xyz_dy.DSC.L3)**                
     .       8            2.00000000000000e+000)**5.00000000000000e-001         
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t150=J1+1,xyz_velsound.DSC.U2+1-xyz_velsound.DSC.L2,4       
     .  !CDIR       NODEP                                                       
     .              do t152 = 1, xyz_velsound.DSC.U1 + 1 - xyz_velsound.DSC.L1  
     .                 xyz_cfl(xyz_cfl.DSC.L1+t152-1,t150-1+xyz_cfl.DSC.L2,t148+
     .       1            xyz_cfl.DSC.L3) = deltimeshort*xyz_velsound(          
     .       2            xyz_velsound.DSC.L1+t152-1,t150-1+xyz_velsound.DSC.L2,
     .       3            t148+xyz_velsound.DSC.L3)*(1.00000000000000e+000/     
     .       4            xyz_dx(xyz_dx.DSC.L1+t152-1,t150-1+xyz_dx.DSC.L2,t148+
     .       5            xyz_dx.DSC.L3)**2.00000000000000e+000+                
     .       6            1.00000000000000e+000/xyz_dy(xyz_dy.DSC.L1+t152-1,t150
     .       7            -1+xyz_dy.DSC.L2,t148+xyz_dy.DSC.L3)**                
     .       8            2.00000000000000e+000)**5.00000000000000e-001         
     .                 xyz_cfl(xyz_cfl.DSC.L1+t152-1,t150+xyz_cfl.DSC.L2,t148+  
     .       1            xyz_cfl.DSC.L3) = deltimeshort*xyz_velsound(          
     .       2            xyz_velsound.DSC.L1+t152-1,t150+xyz_velsound.DSC.L2,  
     .       3            t148+xyz_velsound.DSC.L3)*(1.00000000000000e+000/     
     .       4            xyz_dx(xyz_dx.DSC.L1+t152-1,t150+xyz_dx.DSC.L2,t148+  
     .       5            xyz_dx.DSC.L3)**2.00000000000000e+000+                
     .       6            1.00000000000000e+000/xyz_dy(xyz_dy.DSC.L1+t152-1,t150
     .       7            +xyz_dy.DSC.L2,t148+xyz_dy.DSC.L3)**                  
     .       8            2.00000000000000e+000)**5.00000000000000e-001         
     .                 xyz_cfl(xyz_cfl.DSC.L1+t152-1,t150+1+xyz_cfl.DSC.L2,t148+
     .       1            xyz_cfl.DSC.L3) = deltimeshort*xyz_velsound(          
     .       2            xyz_velsound.DSC.L1+t152-1,t150+1+xyz_velsound.DSC.L2,
     .       3            t148+xyz_velsound.DSC.L3)*(1.00000000000000e+000/     
     .       4            xyz_dx(xyz_dx.DSC.L1+t152-1,t150+1+xyz_dx.DSC.L2,t148+
     .       5            xyz_dx.DSC.L3)**2.00000000000000e+000+                
     .       6            1.00000000000000e+000/xyz_dy(xyz_dy.DSC.L1+t152-1,t150
     .       7            +1+xyz_dy.DSC.L2,t148+xyz_dy.DSC.L3)**                
     .       8            2.00000000000000e+000)**5.00000000000000e-001         
     .                 xyz_cfl(xyz_cfl.DSC.L1+t152-1,t150+2+xyz_cfl.DSC.L2,t148+
     .       1            xyz_cfl.DSC.L3) = deltimeshort*xyz_velsound(          
     .       2            xyz_velsound.DSC.L1+t152-1,t150+2+xyz_velsound.DSC.L2,
     .       3            t148+xyz_velsound.DSC.L3)*(1.00000000000000e+000/     
     .       4            xyz_dx(xyz_dx.DSC.L1+t152-1,t150+2+xyz_dx.DSC.L2,t148+
     .       5            xyz_dx.DSC.L3)**2.00000000000000e+000+                
     .       6            1.00000000000000e+000/xyz_dy(xyz_dy.DSC.L1+t152-1,t150
     .       7            +2+xyz_dy.DSC.L2,t148+xyz_dy.DSC.L3)**                
     .       8            2.00000000000000e+000)**5.00000000000000e-001         
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
    89        &       * ((1.0d0 / (xyz_dx ** 2.0d0) + 1.0d0 / (xyz_dy ** 2.0d0)) ** 0.5d0)
    90  
    91      !å
    92      call MessageNotify( "M", &
     .        if (xyz_velsound.DSC.U2 + 1 - xyz_velsound.DSC.L2 .gt. 0) then    
     .           J2 = and(xyz_velsound.DSC.U2 + 1 - xyz_velsound.DSC.L2,3)      
     .  !CDIR    NODEP                                                          
     .           do t96 = 1, J2                                                 
     .  !CDIR       NODEP                                                       
     .              do t98 = 1, xyz_velsound.DSC.U1 + 1 - xyz_velsound.DSC.L1   
     .                 t92 = max(xyz_velsound(xyz_velsound.DSC.L1+t98-1,t96-1+  
     .       1            xyz_velsound.DSC.L2,t94),t92)                         
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t96=J2+1,xyz_velsound.DSC.U2+1-xyz_velsound.DSC.L2,4        
     .  !CDIR       NODEP                                                       
     .              do t98 = 1, xyz_velsound.DSC.U1 + 1 - xyz_velsound.DSC.L1   
     .                 t92 = max(xyz_velsound(xyz_velsound.DSC.L1+t98-1,t96-1+  
     .       1            xyz_velsound.DSC.L2,t94),xyz_velsound(                
     .       2            xyz_velsound.DSC.L1+t98-1,t96+xyz_velsound.DSC.L2,t94)
     .       3            ,xyz_velsound(xyz_velsound.DSC.L1+t98-1,t96+1+        
     .       4            xyz_velsound.DSC.L2,t94),xyz_velsound(                
     .       5            xyz_velsound.DSC.L1+t98-1,t96+2+xyz_velsound.DSC.L2,  
     .       6            t94),t92)                                             
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
    93        & module_name, &
    94        & "Sound Wave Velocity = %f", d=(/maxval(xyz_VelSound)/) )
    95  !    call MessageNotify( "M", &
    96  !      & module_name, &
    97  !      & "min(DelX, DelY, DelZ) = %f", d=(/DxyzMin/) )
    98      call MessageNotify( "M", &
    99        & module_name, &
   100        & "DelTimeShort = %f", d=(/DelTimeShort/) )
   101  
   102      !ٹå
   103      if ( maxval(xyz_CFL) >= 1.0) then
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t119 = 1, (xyz_cfl.DSC.U3 + 1 - xyz_cfl.DSC.L3)*(xyz_cfl.DSC.U2
     .       1    + 1 - xyz_cfl.DSC.L2)*(xyz_cfl.DSC.U1 + 1 - xyz_cfl.DSC.L1)   
     .           t117 = max(xyz_cfl(xyz_cfl.DSC.L1+t119-1,xyz_cfl.DSC.L2,       
     .       1      xyz_cfl.DSC.L3),t117)                                       
     .        end do                                                            
   104        call MessageNotify( "E", &
   105          & module_name, &
   106          & "CFL Condition is broken, DelTimeShort * VelSound > min(DelX, DelZ)")
   107      else
   108        call MessageNotify( "M", &
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t136 = 1, (xyz_cfl.DSC.U3 + 1 - xyz_cfl.DSC.L3)*(xyz_cfl.DSC.U2
     .       1    + 1 - xyz_cfl.DSC.L2)*(xyz_cfl.DSC.U1 + 1 - xyz_cfl.DSC.L1)   
     .           t134 = max(xyz_cfl(xyz_cfl.DSC.L1+t136-1,xyz_cfl.DSC.L2,       
     .       1      xyz_cfl.DSC.L3),t134)                                       
     .        end do                                                            
   109          & module_name, &
   110          & "Courant number for DelTimeSort = %f", d=(/maxval(xyz_CFL)/) )
   111      end if
   112  
   113    end subroutine CFLCheckTimeShort
   114  
   115  
   116  !!!-----------------------------------------------------------------!!!
   117    subroutine CFLCheckTimeLongVelX( pyz_VelX )
   118      !
   119      !ʿ®٤Ф CFL å.
   120      !
   121  
   122      !ۤηػ
   123      implicit none
   124  
   125      !ѿ
   126      real(DP), intent(in) :: pyz_VelX(imin:imax,jmin:jmax,kmin:kmax)
   127      real(DP)             :: CFL
   128  
   129      !CFL 
   130      CFL = (2.0d0 * DelTimeLong) * maxval(abs(pyz_VelX/xyz_dx))
     .  !CDIR NODEP                                                             
     .        do t44 = 1, imax + 1 - imin                                       
     .           t45 = t44 - 1                                                  
     .           t461 = t42 - 1                                                 
     .           t46 = t461 + t15                                               
     .           t471 = t40 - 1                                                 
     .           t47 = t471 + t17                                               
     .           t49 = t44 - 1                                                  
     .           t501 = t42 - 1                                                 
     .           t50 = t501 + xyz_dx.DSC.L2                                     
     .           t511 = t40 - 1                                                 
     .           t51 = t511 + xyz_dx.DSC.L3                                     
     .           t38 = max(abs(pyz_velx(t45+t13,t46,t47)/xyz_dx(t49+            
     .       1      xyz_dx.DSC.L1,t50,t51)),t38)                                
     .        end do                                                            
   131  
   132      !å
   133      call MessageNotify( "M", &
   134        & module_name, &
   135        & "Courant number of VelX for DelTimeLong = %f", d=(/CFL/) )
   136  
   137  !    if (CFL > 1.0d0) stop
   138  
   139    end subroutine CFLCheckTimeLongVelX
   140  
   141  
   142  !!!-----------------------------------------------------------------!!!
   143    subroutine CFLCheckTimeLongVelY( xqz_VelY )
   144      !
   145      !ʿ®٤Ф CFL å.
   146      !
   147  
   148      !ۤηػ
   149      implicit none
   150  
   151      !ѿ
   152      real(DP), intent(in) :: xqz_VelY(imin:imax,jmin:jmax,kmin:kmax)
   153      real(DP)             :: CFL
   154  
   155      !CFL 
   156      CFL = (2.0d0 * DelTimeLong) * maxval(abs(xqz_VelY/xyz_dy))
     .  !CDIR NODEP                                                             
     .        do t44 = 1, imax + 1 - imin                                       
     .           t45 = t44 - 1                                                  
     .           t461 = t42 - 1                                                 
     .           t46 = t461 + t15                                               
     .           t471 = t40 - 1                                                 
     .           t47 = t471 + t17                                               
     .           t49 = t44 - 1                                                  
     .           t501 = t42 - 1                                                 
     .           t50 = t501 + xyz_dy.DSC.L2                                     
     .           t511 = t40 - 1                                                 
     .           t51 = t511 + xyz_dy.DSC.L3                                     
     .           t38 = max(abs(xqz_vely(t45+t13,t46,t47)/xyz_dy(t49+            
     .       1      xyz_dy.DSC.L1,t50,t51)),t38)                                
     .        end do                                                            
   157  
   158      !å
   159      call MessageNotify( "M", &
   160        & module_name, &
   161        & "Courant number of VelY for DelTimeLong = %f", d=(/CFL/) )
   162  
   163  !    if (CFL > 1.0d0) stop
   164  
   165    end subroutine CFLCheckTimeLongVelY
   166  
   167  
   168  !!!-----------------------------------------------------------------!!!
   169    subroutine CFLCheckTimeLongVelZ( xyr_VelZ )
   170      !
   171      !ʿ®٤Ф CFL å.
   172      !
   173  
   174      !ۤηػ
   175      implicit none
   176  
   177      !ѿ
   178      real(DP), intent(in) :: xyr_VelZ(imin:imax,jmin:jmax,kmin:kmax)
   179      real(DP)             :: CFL
   180  
   181      !CFL 
   182      CFL = (2.0d0 * DelTimeLong) * maxval(abs(xyr_VelZ/xyz_dz))
     .  !CDIR NODEP                                                             
     .        do t44 = 1, imax + 1 - imin                                       
     .           t45 = t44 - 1                                                  
     .           t461 = t42 - 1                                                 
     .           t46 = t461 + t15                                               
     .           t471 = t40 - 1                                                 
     .           t47 = t471 + t17                                               
     .           t49 = t44 - 1                                                  
     .           t501 = t42 - 1                                                 
     .           t50 = t501 + xyz_dz.DSC.L2                                     
     .           t511 = t40 - 1                                                 
     .           t51 = t511 + xyz_dz.DSC.L3                                     
     .           t38 = max(abs(xyr_velz(t45+t13,t46,t47)/xyz_dz(t49+            
     .       1      xyz_dz.DSC.L1,t50,t51)),t38)                                
     .        end do                                                            
   183  
   184      !å
   185      call MessageNotify( "M", &
   186        & module_name, &
   187        & "Courant number of VelZ for DelTimeLong = %f", d=(/CFL/) )
   188  
   189  !    if (CFL > 1.0d0) stop
   190  
   191    end subroutine CFLCheckTimeLongVelZ
   192  
   193  end module CFLCheck
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:33:47 2011
FILE NAME: cflcheck.f90
PROGRAM NAME: cflcheck
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != Module CFLCheck
     2:            !
     3:            ! Authors::   SUGIYAMA Ko-ichiro
     4:            ! Version::   $Id: cflcheck.f90,v 1.2 2011-10-04 05:19:02 sugiyama Exp $ 
     5:            ! Tag Name::  $Name: arare5-20111010 $
     6:            ! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
     7:            ! License::   See COPYRIGHT[link:../../COPYRIGHT]
     8:            !
     9:            !== Overview 
    10:            !
    11:            ! CFL Υå򤹤뤿Υѥå⥸塼
    12:            !   * ȤФ CFL å
    13:            !   * Ϥ줿®٤Ф CFL å
    14:            !
    15:            !== Error Handling
    16:            !
    17:            !== Known Bugs
    18:            !
    19:            !== Note
    20:            !
    21:            !== Future Plans
    22:            !
    23:            !Error Handling  gtool5 Ѥ褦ѹ
    24:            !
    25:            
    26:            module CFLCheck
    27:              !
    28:              !CFL Υå򤹤뤿Υѥå⥸塼
    29:              !  * ȤФ CFL å
    30:              !  * Ϥ줿®٤Ф CFL å
    31:              !
    32:            
    33:              !⥸塼ɤ߹
    34:              use dc_types,   only: DP
    35:              use dc_message, only: MessageNotify
    36:            
    37:              use gridset, only: imin,    &! x β
    38:                &                imax,    &! x ξ
    39:                &                jmin,    &! z β
    40:                &                jmax,    &! z ξ
    41:                &                kmin,    &! z β
    42:                &                kmax      ! z ξ
    43:              use axesset, only: xyz_dX,  &! x γʻֳ
    44:                &                xyz_dY,  &! y γʻֳ
    45:                &                xyz_dZ    ! z γʻֳ
    46:              use timeset, only: DelTimeShort,  &!û֥ƥå
    47:                &                DelTimeLong     !Ĺ֥ƥå
    48:            
    49:              !ۤηػ
    50:              implicit none
    51:            
    52:              !private °λ
    53:              private
    54:            
    55:              !
    56:              character(*), parameter:: module_name = 'cflcheck'
    57:                                          ! ⥸塼̾.
    58:                                          ! Module name
    59:              
    60:              !ؿ public °
    61:              public CFLCheckTimeShort
    62:              public CFLCheckTimeLongVelX
    63:              public CFLCheckTimeLongVelY
    64:              public CFLCheckTimeLongVelZ
    65:              
    66:            contains  
    67:            
    68:            !!!-----------------------------------------------------------------!!!
    69:              subroutine CFLCheckTimeShort( xyz_VelSound )
    70:                !
    71:                !ȤФ CFL å
    72:                ! 
    73:            
    74:                !ۤηػ
    75:                implicit none
    76:                
    77:                !ѿ
    78:                real(DP), intent(in) :: xyz_VelSound(imin:imax,jmin:jmax, kmin:kmax)
    79:                                                    !®
    80:                real(DP)             :: xyz_CFL(imin:imax,jmin:jmax, kmin:kmax)
    81:                                                    !
    82:            !    real(DP)             :: DxyzMin      !ǾʻҴֳ
    83:                
    84:                !® CFL 
    85:            !    DxyzMin = min(min(minval(xyz_dx), minval(xyz_dy)), minval(xyz_dz))
    86:            !    CFL = DelTimeShort * maxval(xyz_VelSound) / DxyzMin
    87:            
    88: ++V====        xyz_CFL = DelTimeShort * xyz_VelSound       &
    89:                  &       * ((1.0d0 / (xyz_dx ** 2.0d0) + 1.0d0 / (xyz_dy ** 2.0d0)) ** 0.5d0)
    90:            
    91:                !å
    92: ++V====        call MessageNotify( "M", &
    93:                  & module_name, &
    94:                  & "Sound Wave Velocity = %f", d=(/maxval(xyz_VelSound)/) )
    95:            !    call MessageNotify( "M", &
    96:            !      & module_name, &
    97:            !      & "min(DelX, DelY, DelZ) = %f", d=(/DxyzMin/) )
    98:                call MessageNotify( "M", &
    99:                  & module_name, &
   100:                  & "DelTimeShort = %f", d=(/DelTimeShort/) )
   101:            
   102:                !ٹå
   103: WW+====        if ( maxval(xyz_CFL) >= 1.0) then 
   104:                  call MessageNotify( "E", &
   105:                    & module_name, &
   106:                    & "CFL Condition is broken, DelTimeShort * VelSound > min(DelX, DelZ)")
   107:                else
   108: +++====          call MessageNotify( "M", &
   109:                    & module_name, &
   110:                    & "Courant number for DelTimeSort = %f", d=(/maxval(xyz_CFL)/) )
   111:                end if
   112:              
   113:              end subroutine CFLCheckTimeShort
   114:            
   115:            
   116:            !!!-----------------------------------------------------------------!!!
   117:              subroutine CFLCheckTimeLongVelX( pyz_VelX )
   118:                !
   119:                !ʿ®٤Ф CFL å. 
   120:                ! 
   121:            
   122:                !ۤηػ
   123:                implicit none
   124:                
   125:                !ѿ
   126:                real(DP), intent(in) :: pyz_VelX(imin:imax,jmin:jmax,kmin:kmax)
   127:                real(DP)             :: CFL
   128:            
   129:                !CFL 
   130: ++V====        CFL = (2.0d0 * DelTimeLong) * maxval(abs(pyz_VelX/xyz_dx))
   131:              
   132:                !å
   133:                call MessageNotify( "M", &
   134:                  & module_name, &
   135:                  & "Courant number of VelX for DelTimeLong = %f", d=(/CFL/) )
   136:            
   137:            !    if (CFL > 1.0d0) stop 
   138:            
   139:              end subroutine CFLCheckTimeLongVelX
   140:                
   141:            
   142:            !!!-----------------------------------------------------------------!!!
   143:              subroutine CFLCheckTimeLongVelY( xqz_VelY )
   144:                !
   145:                !ʿ®٤Ф CFL å. 
   146:                ! 
   147:            
   148:                !ۤηػ
   149:                implicit none
   150:                
   151:                !ѿ
   152:                real(DP), intent(in) :: xqz_VelY(imin:imax,jmin:jmax,kmin:kmax)
   153:                real(DP)             :: CFL
   154:            
   155:                !CFL 
   156: ++V====        CFL = (2.0d0 * DelTimeLong) * maxval(abs(xqz_VelY/xyz_dy))
   157:              
   158:                !å
   159:                call MessageNotify( "M", &
   160:                  & module_name, &
   161:                  & "Courant number of VelY for DelTimeLong = %f", d=(/CFL/) )
   162:            
   163:            !    if (CFL > 1.0d0) stop 
   164:            
   165:              end subroutine CFLCheckTimeLongVelY
   166:            
   167:            
   168:            !!!-----------------------------------------------------------------!!!
   169:              subroutine CFLCheckTimeLongVelZ( xyr_VelZ )
   170:                !
   171:                !ʿ®٤Ф CFL å. 
   172:                ! 
   173:            
   174:                !ۤηػ
   175:                implicit none
   176:                
   177:                !ѿ
   178:                real(DP), intent(in) :: xyr_VelZ(imin:imax,jmin:jmax,kmin:kmax)
   179:                real(DP)             :: CFL
   180:                
   181:                !CFL 
   182: ++V====        CFL = (2.0d0 * DelTimeLong) * maxval(abs(xyr_VelZ/xyz_dz)) 
   183:                
   184:                !å
   185:                call MessageNotify( "M", &
   186:                  & module_name, &
   187:                  & "Courant number of VelZ for DelTimeLong = %f", d=(/CFL/) )
   188:                
   189:            !    if (CFL > 1.0d0) stop 
   190:            
   191:              end subroutine CFLCheckTimeLongVelZ
   192:              
   193:            end module CFLCheck
